#include <iostream>
#include <vector>
#include <algorithm>

/**
	Conceptually : UNNAMED function objects created "ON THE FLY"
*/

void shorthand(const std::vector<int>& vec);

int main()
{
	const std::vector<int> vec = {101, 102, 2, 5, 11};

	auto it = std::find_if(vec.cbegin(), vec.cend(),
				[](int i){return i > 0 && i < 10;});

	std::cout << "found : " << *it;


	std::cout << std::endl << std::endl << std::endl;
	shorthand(vec);

    return 0;
}

/**
	actually : shorthand for CREATING and USING function objects

	we call such function objects : CLOSURES
*/

void shorthand(const std::vector<int>& vec)
{
	class MagicType
	{
	public:
		bool operator()(int i) const
		{
			return i > 0 && i < 10;
		}
	};

	auto it = std::find_if(vec.cbegin(), vec.cend(), MagicType());
	std::cout << "found : " << *it;
}
