#include <iostream>
#include <set>
#include <algorithm>

/**  another interesting use
*/

int main()
{
	auto compareFunc = [](int* i1, int* i2) {return *i1 < *i2;};

	int a1 = 10;
	int a2 = 30;
	int a3 = 20;

	std::set<int*, decltype(compareFunc)> s(compareFunc);
	s.insert(&a1);
	s.insert(&a2);
	s.insert(&a3);

	std::for_each(s.cbegin(), s.cend(),
				[](int* i) {std::cout << *i << " ";});
	std::cout << std::endl << std::endl << std::endl;

//	std::set<int*, decltype(compareFunc)> s2; // <--- does NOT compile because closure types might not be "default constructible"

    return 0;
}

/****
	decltype(compareFunc) : return as a type the declared type of compareFunc
*******/
