#include <iostream>
#include <vector>
#include <algorithm>

void shorthand();

int main()
{
	std::vector<int> vec = {101, 102, 2, 5, 11};

	std::sort(vec.begin(), vec.end(),
				[](int i1, int i2) {return -i1 < -i2;});

	std::for_each(vec.cbegin(), vec.cend(),
				[](int i) {std::cout << i << " ";});

	std::cout << std::endl << std::endl << std::endl;
	shorthand();

    return 0;
}

void shorthand()
{
	std::vector<int> vec = {101, 102, 2, 5, 11};

	class MagicType1
	{
	public:
		bool operator()(int i1, int i2) const
		{
			return -i1 < -i2;
		}
	};

	std::sort(vec.begin(), vec.end(), MagicType1());

	class MagicType2
	{
	public:
		void operator()(int i) const
		{
			std::cout << i << " ";
		}
	};

	std::for_each(vec.cbegin(), vec.cend(), MagicType2());
}
