#include <iostream>
#include <vector>
#include <algorithm>

/** CAPTURING local variables (from the context)
		by REFERENCE
*/

void shorthand();

int main()
{
	int minVal = 0;
	double maxVal = 10;
	std::vector<int> vec = {101, 102, 2, 5, 11};

	auto it = std::find_if(vec.cbegin(), vec.cend(),
				[&minVal, &maxVal](int i){return i > minVal && i < maxVal;});

	std::cout << "found : " << *it;

	std::cout << std::endl << std::endl << std::endl;
	shorthand();

    return 0;
}

void shorthand()
{
	int minVal = 0;
	double maxVal = 10;
	std::vector<int> vec = {101, 102, 2, 5, 11};

	class MagicType1
	{
	public:
		MagicType1(int& v1, double& v2) :
			mMinVal(v1), mMaxVal(v2) {}
		bool operator()(int i) const
		{
			return i > mMinVal && i < mMaxVal;
		}
	private:
		int& mMinVal;
		double& mMaxVal;
	};

	auto it = std::find_if(vec.cbegin(), vec.cend(), MagicType1(minVal, maxVal));
	std::cout << "found : " << *it;
}
