#include <iostream>
#include <vector>
#include <algorithm>

/** CAPTURING local variables (from the context)
		by specifying CAPTURE MODE DEFAULTS

		default is by value [=]
*/

int main()
{
	int minVal = 0;
	double maxVal = 10;
	std::vector<int> vec = {101, 102, 2, 5, 11};

	auto it = std::find_if(vec.cbegin(), vec.cend(),
				[=](int i){return i > minVal && i < maxVal;});

	std::cout << "found : " << *it;

	std::cout << std::endl << std::endl << std::endl;


	/** default by reference [&] */

	auto it2 = std::find_if(vec.cbegin(), vec.cend(),
				[&](int i){return i > minVal && i < maxVal;});

	std::cout << "found : " << *it2;

    return 0;
}
