#include <iostream>
#include <vector>
#include <algorithm>

/** CAPTURING    CLASS MEMBERS
		within a member function
*/

class Test
{
public:
	Test() :
		mVec({11, 2, 5, 101, 102,}),
		mMinVal(100)
	{

	}
	void doSomething();
	void doSomething2();
	void doSomething3();
	void doSomething4();
	void doSomething5();
	void doSomething6();
private:
	std::vector<int> mVec;
	int mMinVal;
};

int main()
{
	Test t;
	t.doSomething();
	std::cout << std::endl << std::endl << std::endl;

	t.doSomething2();
	std::cout << std::endl << std::endl << std::endl;

	t.doSomething3();
	std::cout << std::endl << std::endl << std::endl;

	t.doSomething4();
	std::cout << std::endl << std::endl << std::endl;

	t.doSomething5();
	std::cout << std::endl << std::endl << std::endl;

	t.doSomething6();
	std::cout << std::endl << std::endl << std::endl;

    return 0;
}

void Test::doSomething()
{
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[this](int i){return i > mMinVal;});
	std::cout << "found : " << *it;
}

void Test::doSomething2()
{
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[this](int i){return i > this->mMinVal;});
	std::cout << "found : " << *it;
}

void Test::doSomething3()
{
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[=](int i){return i > mMinVal;});
	std::cout << "found : " << *it;
}

void Test::doSomething4()
{
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[&](int i){return i > mMinVal;});
	std::cout << "found : " << *it;
}


void Test::doSomething5()
{
	int mMinVal = 1; // lets use the m prefix here for demo purposes
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[mMinVal, this](int i){return i > (this->mMinVal + mMinVal);});
	std::cout << "found : " << *it;
}

void Test::doSomething6()
{
	int mMinVal = 1; // lets use the m prefix here for demo purposes
	auto it = std::find_if(mVec.cbegin(), mVec.cend(),
				[=](int i){return i > (this->mMinVal + mMinVal);});
	std::cout << "found : " << *it;
}
