#include <iostream>
#include <algorithm>
#include <vector>

namespace
{
struct MyFunctor
{
    explicit MyFunctor(const std::string& prefix) : mPrefix{prefix} {}
    void operator()(int x) const
    {
        ++mInvocations;
        std::cout << mPrefix << " : " << x << "\n";
    }

    const std::string mPrefix;
    mutable int mInvocations = 0;
};
}

int main()
{
    const std::vector<int> myVec{1, 10, 100, 1000};

    MyFunctor mf{"Value"};
    const auto mf2 = std::for_each(myVec.cbegin(), myVec.cend(), mf);

    std::cout << "\n" << mf2.mInvocations << "\n";
    return 0;
}
